/* Reference: http://library.gnome.org/devel/gtk/stable/GtkBuilder.html */
/* Tutorials: */
/* http://tadeboro.blogspot.com/2009/09/glade3-tutorial-1-introduction.html */
/* http://www.micahcarrick.com/12-24-2007/gtk-glade-tutorial-part-1.html */

#include <gtk/gtk.h>

#include "handlers.c"

int
main (int argc, char *argv[])
{
	/* UI loader object */
    GtkBuilder *builder;
    GtkWidget *widget;

    gtk_init (&argc, &argv);

	/* create a new GtkBuilder object */
    builder = gtk_builder_new ();

	/* load UI from file */
    gtk_builder_add_from_file (builder, "desk.xml", NULL);

    /* get a widget (useful if you want to change something) */
    widget = GTK_WIDGET (gtk_builder_get_object (builder, "drawingarea"));

    /* autoconnect signal handlers */
    gtk_builder_connect_signals (builder, NULL);

	/* destroy GtkBuilder object, since we don't need it anymore */
    g_object_unref (G_OBJECT (builder));

    /* show UI (because of the realize signal the widget is not
	 * visible) */
    gtk_widget_show (widget);

    gtk_main ();

    return 0;
}
