#include <gtk/gtk.h>

#include "handlers.c"

GtkWidget *desk_new()
{
  GtkWidget *window, *area;

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (window, "window");
  gtk_window_set_title (GTK_WINDOW (window), "Desk Demo");
  g_signal_connect (G_OBJECT (window), "destroy",
		    G_CALLBACK (gtk_main_quit), NULL);

  // a widget for simple drawing purposes
  area = gtk_drawing_area_new ();
  gtk_widget_set_size_request (area, 500, 500);
  g_signal_connect (G_OBJECT (area), "realize",
		    G_CALLBACK (on_drawingarea_realize), NULL);
  g_signal_connect (G_OBJECT (area), "expose_event",
		    G_CALLBACK (on_drawingarea_expose_event), NULL);
  g_signal_connect (G_OBJECT(area), "configure_event",
		    G_CALLBACK (on_drawingarea_configure_event), NULL);

  g_signal_connect (G_OBJECT (area), "button_press_event",
		    G_CALLBACK (on_drawingarea_button_press_event), NULL);
  g_signal_connect (G_OBJECT (area), "motion_notify_event",
		    G_CALLBACK (on_drawingarea_motion_notify_event), NULL);
  // need to unmask some events in order to obtain the events
  gtk_widget_add_events (area, GDK_EXPOSURE_MASK | GDK_STRUCTURE_MASK
			 | GDK_BUTTON_PRESS_MASK
			 | GDK_POINTER_MOTION_MASK
			 | GDK_POINTER_MOTION_HINT_MASK);

  gtk_container_add (GTK_CONTAINER (window), area);
  gtk_widget_show (area);

  return window;
}

int main(int argc, char *argv[])
{
  GtkWidget *desk;

  gtk_init (&argc, &argv);

  desk = desk_new();

  gtk_widget_show (desk);

  gtk_main ();

  return 0;
}
