#ifndef AREA_H
#define AREA_H

#include <QWidget>
#include <QPixmap>
#include <QPainter>

// sub-classed widget
class Area : public QWidget
{
 public:
  Area(QWidget *parent = 0);
protected:
  struct Board {
	  const int n;
	  int size;
	  QColor colors[2];
	  // a pixmap for drawing not directly on a widget
	  QPixmap pixmap;
  Board() : n(8), pixmap(1,1) {}
  } board;

  struct Man {
	  const float ratio;
	  int x;
	  int y;
	  int size;
	  QColor color;
  Man() : ratio((float)3/4) {}
  } man;

  struct {
	  int dragging;
	  int x_old;
	  int y_old;
  } drag_data;

  void draw_board(QPainter *painter);
  void draw_man(QPainter *painter);
  void draw();
  // overloaded resize event handler
  void resizeEvent(QResizeEvent *event);
  // overloaded paint event handler: repaint a (part of the) widget
  void paintEvent(QPaintEvent *event);
  // overloaded mouse button press event handler
  void mousePressEvent(QMouseEvent *event);
  // overloaded mouse motion event handler
  void mouseMoveEvent(QMouseEvent *event);
};

#endif // AREA_H
