#include "area.h"
#include "area_plugin.h"

#include <QtPlugin>

AreaPlugin::AreaPlugin(QObject *parent)
	: QObject(parent)
{
	initialized = false;
}

void AreaPlugin::initialize(QDesignerFormEditorInterface *core)
{
	if (initialized)
		return;

	initialized = true;
}

bool AreaPlugin::isInitialized() const
{
	return initialized;
}

QWidget *AreaPlugin::createWidget(QWidget *parent)
{
	return new Area(parent);
}

QString AreaPlugin::name() const
{
	return "Area";
}

QString AreaPlugin::group() const
{
	return "Custom Widgets";
}

QIcon AreaPlugin::icon() const
{
	// default icon
	return QIcon();
}

QString AreaPlugin::toolTip() const
{
	return "Game desk";
}

QString AreaPlugin::whatsThis() const
{
	return "Game desk widget";
}

bool AreaPlugin::isContainer() const
{
	return false;
}

QString AreaPlugin::domXml() const
{
	return "<ui language=\"c++\">\n"
		" <widget class=\"Area\" name=\"area\">\n"
		"  <property name=\"geometry\">\n"
		"   <rect>\n"
		"    <x>0</x>\n"
		"    <y>0</y>\n"
		"    <width>100</width>\n"
		"    <height>100</height>\n"
		"   </rect>\n"
		"  </property>\n"
		"  <property name=\"toolTip\" >\n"
		"   <string>Game desk</string>\n"
		"  </property>\n"
		"  <property name=\"whatsThis\" >\n"
		"   <string>Game desk widget</string>\n"
		"  </property>\n"
		" </widget>\n"
		"</ui>\n";
}

QString AreaPlugin::includeFile() const
{
	return "area.h";
}

Q_EXPORT_PLUGIN2(customwidgetplugin, AreaPlugin)
