// Reference: http://qt.nokia.com/doc/4.6/qdesignercustomwidgetinterface.html
// Tutorial: http://qt.nokia.com/doc/4.6/designer-customwidgetplugin.html

#ifndef AREA_PLUGIN_H
#define AREA_PLUGIN_H

#include <QDesignerCustomWidgetInterface>

// Qt Designer (and QUiLoader) plugin interface
class AreaPlugin : public QObject, public QDesignerCustomWidgetInterface
{
	Q_OBJECT
		Q_INTERFACES(QDesignerCustomWidgetInterface)

		public:
	AreaPlugin(QObject *parent = 0);

	bool isContainer() const;
	bool isInitialized() const;
	// icon in Qt Designer
	QIcon icon() const;
	// default settings in XML produced by Qt Designer
	QString domXml() const;
	// widget's group in Qt Designer
	QString group() const;
	// widget header file for code generation
	QString includeFile() const;
	// name of the widget in Qt Designer
	QString name() const;
	// tooltip on the widget in Qt Designer
	QString toolTip() const;
	// What's this help in Qt Designer
	QString whatsThis() const;
	// widget constructor
	QWidget *createWidget(QWidget *parent);
	void initialize(QDesignerFormEditorInterface *core);
private:
	bool initialized;
};

#endif /* AREA_PLUGIN_H */
